--[[
1.拿到宿主期望宽高
bannerView:getViewWidth()
bannerView:getViewHeight()
2.拿到广告数据 json字符串
bannerView:getADContent()
3.筛选素材后下载素材
bannerView:downloadSource
4.宿主告知素材下载成功
sourceReady(数组{url，path，md5})
5.告诉宿主广告准备成功
bannerView:loadSuccess(size{width,height})
6.宿主告诉lua 是否已经展示在屏幕里
showView()
hideView()
7.宿主告诉lua 销毁
destroy
]]--

--版本控制逻辑
function Split( str,reps )
    local resultStrList = {}
    string.gsub(str,'[^'..reps..']+',function ( w )
        table.insert(resultStrList,w)
    end)
    return resultStrList
end

function getSDKVersion()
    local version = LiLuaADUtils:getADSDKVersion()
    local list = Split(version, ".")
    if #list >= 3 then
        return tonumber(list[1]) * 10000 + tonumber(list[2]) * 100 + tonumber(list[3])
    end
    return 0
end

function isCheckMoreExpVersion()
    local version = getSDKVersion()
    print("isCheckMoreExpVersion "..tostring(version))
    if version >= 30 then
        return true
    end
    return false
end

local isCheckExpVersion = isCheckMoreExpVersion()

--筛选逻辑
----------------------------------------------------------------------
local width = bannerView:getViewWidth()
local height = bannerView:getViewHeight()

local margin = 10
local iconMargin = 14

local actWidth = width
local actHeight = height
local adContent = Json:toTable(bannerView:getADContent())

local plans = adContent["plans"]
local plan = plans[1]
local creatives = plan["creatives"]
local creative = creatives[1]
local extendParam = creative["extendParam"]
local videoList = extendParam["videoList"]

local icon = {}
local iconPostion = extendParam["labelIcon"]["position"]
icon["url"] = extendParam["labelIcon"]["image"]["url"]
icon["md5"] = extendParam["labelIcon"]["image"]["md5"]

local video = {}
video["url"] = videoList[1]["url"]
video["md5"] = videoList[1]["md5"]

local contentWidth = actWidth - margin * 2
local contentHeight = contentWidth * videoList[1]["height"] / videoList[1]["width"]

actHeight = margin * 2 + contentHeight

local sound_mute = {}
local soundPostion = extendParam["muteIcon"]["position"]
sound_mute["url"] = extendParam["muteIcon"]["muteImage"]["url"]
sound_mute["md5"] = extendParam["muteIcon"]["muteImage"]["md5"]
local sound_unmute = {}
sound_unmute["url"] = extendParam["muteIcon"]["unmuteImage"]["url"]
sound_unmute["md5"] = extendParam["muteIcon"]["unmuteImage"]["md5"]
local source = {icon,video,sound_mute,sound_unmute}
local cover = {}
if videoList[1]["cover"] ~= nil and videoList[1]["cover"]["url"] ~= nil then
    cover["url"] = videoList[1]["cover"]["url"]
    cover["md5"] = videoList[1]["cover"]["md5"]
    source[5] = cover
end

--资源下载
bannerView:downloadSource(source)

local videoTrackArr = creative["videoTrackArr"]

local basedata = {}
basedata["lid"] = string.format("%d",adContent["lid"])
basedata["pid"] = string.format("%d",plan["pid"])
basedata["cid"] = string.format("%d",creative["cid"])

local player = nil

local iconImage = nil

local soundImage = nil

local isSoundMute = false

local soundMargin = 10;

local iconWidth = 27

local iconHeight = 19

local soundWidth = 25

local soundHeight = 25

local checkExpShow = false

function getBaseData()
    local data = {}
    for k,v in pairs(basedata) do
        data[k] = v                                                     
    end
    return data
end

--lua bj 广告展示在当前屏幕
function showView()
    print("showView")
    local logData = getBaseData()
    logData["url"] = ""
    logData["act"] = "exp"
    if checkExpShow == false then
        checkExpShow = true
        if isCheckExpVersion then
            logData["monitorUrl"] = creative["expTrackArr"]
            bannerView:adActionExpClickLog(logData)
        else
            logData["monitorUrl"] = creative["expTrack"]
            bannerView:adActionLog(logData)
        end
    end

    if player == nil then
        local contentBg = View()
        contentBg:backgroundColor(0xffffff)
        contentBg:frame(0,0,actWidth,actHeight)

        player = VideoPlayer()
        player:callback{
            onStart = function(url)
                print("onstart url = "..url)
            end,
            onFinished = function(url)
                print("onFinished url = "..url)
            end,
            onProgress = function(url,playTime,totalTime)
                print("onProgress url = "..url.."playTime="..playTime.." totalTime="..totalTime)
                if videoTrackArr ~= nil and #videoTrackArr > 0 then
                    for i in pairs(videoTrackArr) do
                        local trackTable = videoTrackArr[i]
                        if playTime >= trackTable["timePoint"] and trackTable["isShow"] == nil then
                            trackTable["isShow"] = "1"
                            local logData = getBaseData()
                            logData["url"] = ""
                            logData["act"] = "exp"
                            logData["monitorUrl"] = trackTable["trackUrls"]
                            bannerView:adActionExpClickLog(logData)
                        end
                        if playTime < trackTable["timePoint"] and trackTable["isShow"] ~= nil then
                            trackTable["isShow"] = nil
                        end
                    end
                end
            end,
            onError = function()
                print("onError")
                local logData = getBaseData()
                logData["act"] = "log"
                local log = {}
                log["type"] = "5"
                log["extraInfo"] = video["url"]
                logData["log"] = log
                bannerView:adActionLog(logData)
            end,
            onClick = function()
                print("onClick")
                local logData = getBaseData()
                logData["act"] = "clk"
                logData["url"] = creative["click"]
                if isCheckExpVersion then
                    logData["monitorUrl"] = creative["clkTrackArr"]
                    bannerView:adActionExpClickLog(logData)
                else
                    logData["monitorUrl"] = creative["clkTrack"]
                    bannerView:adActionLog(logData)
                end
            end
        }
        player:frame(margin, margin, contentWidth, contentHeight)
        if cover["path"] ~= nil then
            player:startPlay(video["path"],cover["path"],"1")
        else
            player:startPlay(video["path"],"","1")
        end
        
        iconImage = Image()
        iconImage:frame(margin,margin,iconWidth,iconHeight)
        iconImage:image(icon["path"])
        iconImage:scaleType(ScaleType.FIT_XY)
        iconImage:show()
        if iconPostion == 1 then
            iconImage:frame(iconMargin,iconMargin,iconWidth,iconHeight)
        elseif iconPostion == 2 then
            iconImage:frame(actWidth - iconWidth - iconMargin,iconMargin,iconWidth,iconHeight)
        elseif iconPostion == 3 then
            iconImage:frame(iconMargin,actHeight - iconHeight - iconMargin,iconWidth,iconHeight)
        elseif iconPostion == 4 then
            iconImage:frame(actWidth - iconWidth - iconMargin,actHeight - iconHeight- iconMargin,iconWidth,iconHeight)
        else
            iconImage:hide()
        end

        soundImage = Image()
        soundImage:scaleType(ScaleType.FIT_XY)
        soundImage:frame(actWidth - soundMargin - soundWidth - margin,soundMargin + margin,soundWidth,soundHeight)
        soundImage:show()

        if soundPostion == 1 then
            soundImage:frame(soundMargin + margin,soundMargin + margin,soundWidth,soundHeight)
        elseif soundPostion == 2 then
            soundImage:frame(actWidth - soundMargin - soundWidth - margin,soundMargin + margin,soundWidth,soundHeight)
        elseif soundPostion == 3 then
            soundImage:frame(soundMargin + margin,actHeight - soundMargin - soundHeight - margin,soundWidth,soundHeight)
        elseif soundPostion == 4 then
            soundImage:frame(actWidth - soundMargin - soundWidth - margin,actHeight - soundMargin - soundHeight - margin,soundWidth,soundHeight)
        else
            soundImage:hide()
        end
        
        if isSoundMute then
            soundImage:image(sound_unmute["path"])
            player:voice(0.5)
        else
            soundImage:image(sound_mute["path"])
            player:voice(0)
        end
        soundImage:callback(function()
            if isSoundMute then
                isSoundMute = false
                soundImage:image(sound_mute["path"])
                player:voice(0)
            else
                isSoundMute = true
                soundImage:image(sound_unmute["path"])
                player:voice(0.5)
            end
            print("sound click")
        end)
    else
        isSoundMute = false
        soundImage:image(sound_mute["path"])
        player:voice(0)
        player:restartPlay()
    end
end

--lua bj 广告没有展示在当前屏幕
function hideView()
	print("hideView")
    if player ~= nil then
        isSoundMute = false
        soundImage:image(sound_mute["path"])
        player:voice(0)
        player:pausePlay()
	end
end

--lua bj 手动调用离开屏幕，进入屏幕还是showView
function leaveScreen()
    print("leaveScreen")
    if player ~= nil then
        isSoundMute = false
        soundImage:image(sound_mute["path"])
        player:voice(0)
	end
end

--lua bj 资源准备完成
function sourceReady(sourcedata)
    print("sourceReady")
    for i in pairs(sourcedata) do
        if sourcedata[i]["url"] == icon["url"] then
            icon["path"] = sourcedata[i]["path"]
        elseif sourcedata[i]["url"] == video["url"] then
            video["path"] = sourcedata[i]["path"]
        elseif cover["url"] ~= nil and sourcedata[i]["url"] == cover["url"] then
            cover["path"] = sourcedata[i]["path"]
        elseif sourcedata[i]["url"] == sound_mute["url"] then
            sound_mute["path"] = sourcedata[i]["path"]
        elseif sourcedata[i]["url"] == sound_unmute["url"] then
            sound_unmute["path"] = sourcedata[i]["path"]
        end
    end 
    local size = {}
    size.width = actWidth
    size.height = actHeight

    --打请求成功日志
    local logData = getBaseData()
    logData["act"] = "req"
    bannerView:adActionLog(logData)

    bannerView:loadSuccess(size)
end

--lua bj 所有资源销毁
function destroy()
    print("destroy")
    if player ~= nil then
        player:destroy()
    end
    System.gc()
end
