--[[
1.拿到宿主期望宽高
bannerView:getViewWidth()
bannerView:getViewHeight()
2.拿到广告数据 json字符串
bannerView:getADContent()
3.筛选素材后下载素材
bannerView:downloadSource
4.宿主告知素材下载成功
sourceReady(数组{url，path，md5})
5.告诉宿主广告准备成功
bannerView:loadSuccess(size{width,height})
6.宿主告诉lua 是否已经展示在屏幕里
showView()
hideView()
7.宿主告诉lua 销毁
destroy
]]--

--版本控制逻辑
function Split( str,reps )
    local resultStrList = {}
    string.gsub(str,'[^'..reps..']+',function ( w )
        table.insert(resultStrList,w)
    end)
    return resultStrList
end

function getSDKVersion()
    local version = LiLuaADUtils:getADSDKVersion()
    local list = Split(version, ".")
    if #list >= 3 then
        return tonumber(list[1]) * 10000 + tonumber(list[2]) * 100 + tonumber(list[3])
    end
    return 0
end

function isCheckMoreExpVersion()
    local version = getSDKVersion()
    print("isCheckMoreExpVersion "..tostring(version))
    if version >= 30 then
        return true
    end
    return false
end

local isCheckExpVersion = isCheckMoreExpVersion()

local width = bannerView:getViewWidth()
local height = bannerView:getViewHeight()

local contentWidth = width
local contentHeight = height

local scale = height / width

local adContent = Json:toTable(bannerView:getADContent())

local plans = adContent["plans"]
local plan = plans[1]
local creatives = plan["creatives"]
local creative = creatives[1]
local extendParam = creative["extendParam"]
local videoList = extendParam["videoList"]
local showTime = extendParam["displayTime"]

local icon = {}
local iconPostion = extendParam["labelIcon"]["position"]
icon["url"] = extendParam["labelIcon"]["image"]["url"]
icon["md5"] = extendParam["labelIcon"]["image"]["md5"]

local index = 1
local scales = {}
for i in pairs(videoList) do
    scales[i] = math.abs(videoList[i]["height"] / videoList[i]["width"] - scale)
end
for i in pairs(scales) do
    if scales[i] < scales[index] then
        index = i
    end
end

local scale2 = videoList[index]["height"] / videoList[index]["width"]
if contentWidth * scale2 > contentHeight then
    contentHeight = contentWidth * scale2
else
    contentWidth = contentHeight / scale2
end

local video = {}
video["url"] = videoList[index]["url"]
video["md5"] = videoList[index]["md5"]

local logo = {}
logo["url"] = extendParam["splashLogoFull"]["url"]
logo["md5"] = extendParam["splashLogoFull"]["md5"]

local rectangle = {}
rectangle["url"] = extendParam["countIcon"]["url"]
rectangle["md5"] = extendParam["countIcon"]["md5"]

local clickIcon = {}
clickIcon["url"] = extendParam["clickIcon"]["url"]
clickIcon["md5"] = extendParam["clickIcon"]["md5"]

local source = {icon,video,logo,rectangle,clickIcon}

local cover = {}
if videoList[index]["cover"] ~= nil and videoList[index]["cover"]["url"] ~= nil then
    cover["url"] = videoList[index]["cover"]["url"]
    cover["md5"] = videoList[index]["cover"]["md5"]
    source[6] = cover
end

--资源下载
bannerView:downloadSource(source)

local videoTrackArr = creative["videoTrackArr"]

local basedata = {}
basedata["lid"] = string.format("%d",adContent["lid"])
basedata["pid"] = string.format("%d",plan["pid"])
basedata["cid"] = string.format("%d",creative["cid"])

local player = nil

local iconImage = nil

local logoImage = nil

local timer = nil

local timeLabel = nil

local timeBg = nil

local clickImage = nil

local iconWidth = 32

local iconHeight = 22

local padLeft = (contentWidth - width) / 2

local padTop = (contentHeight - height) / 2

local checkExpShow = false

function getBaseData()
    local data = {}
    for k,v in pairs(basedata) do
        data[k] = v                                                     
    end
    return data
end

--lua bj 广告展示在当前屏幕
function showView()
    print("showView")
    local logData = getBaseData()
    logData["url"] = ""
    logData["act"] = "exp"
    if checkExpShow == false then
        checkExpShow = true
        if isCheckExpVersion then
            logData["monitorUrl"] = creative["expTrackArr"]
            bannerView:adActionExpClickLog(logData)
        else
            logData["monitorUrl"] = creative["expTrack"]
            bannerView:adActionLog(logData)
        end
    end

    if player == nil then
        player = VideoPlayer()
        player:callback{
            onStart = function(url)
                print("onstart url = "..url)
            end,
            onFinished = function(url)
                print("onFinished url = "..url)
                --bannerView:adActionClose()
            end,
            onProgress = function(url,playTime,totalTime)
                print("onProgress url = "..url.."playTime="..playTime.." totalTime="..totalTime)
                if videoTrackArr ~= nil and #videoTrackArr > 0 then
                    for i in pairs(videoTrackArr) do
                        local trackTable = videoTrackArr[i]
                        if playTime >= trackTable["timePoint"] and trackTable["isShow"] == nil then
                            trackTable["isShow"] = "1"
                            local logData = getBaseData()
                            logData["url"] = ""
                            logData["act"] = "exp"
                            logData["monitorUrl"] = trackTable["trackUrls"]
                            bannerView:adActionExpClickLog(logData)
                        end
                        if playTime < trackTable["timePoint"] and trackTable["isShow"] ~= nil then
                            trackTable["isShow"] = nil
                        end
                    end
                end
            end,
            onError = function()
                print("onError")
                local logData = getBaseData()
                logData["act"] = "log"
                local log = {}
                log["type"] = "5"
                log["extraInfo"] = video["url"]
                logData["log"] = log
                bannerView:adActionLog(logData)
            end
        }
        player:frame(0, 0, contentWidth, contentHeight)
        if cover["path"] ~= nil then
            player:startPlay(video["path"],cover["path"])
        else
            player:startPlay(video["path"])
        end
        player:voice(0)

        local cView = View()
        cView:frame(padLeft,padTop,width,height)
        cView:callback(function()
            print("player click")

        end)
        
        iconImage = Image()
        iconImage:frame(12,26,iconWidth,iconHeight)
        iconImage:image(icon["path"])
        iconImage:scaleType(ScaleType.FIT_XY)
        iconImage:show()
        if iconPostion == 1 then
            iconImage:frame(12,26,iconWidth,iconHeight)
        elseif iconPostion == 2 then
            iconImage:frame(width - 10 - iconWidth,40,iconWidth,iconHeight)
        elseif iconPostion == 3 then
            iconImage:frame(12,height - iconHeight - 20,iconWidth,iconHeight)
        elseif iconPostion == 4 then
            iconImage:frame(width - 10 - iconWidth,height - iconHeight - 20,iconWidth,iconHeight)
        else
            iconImage:hide()
        end
        cView:addView(iconImage)

        logoImage = Image()
        logoImage:scaleType(ScaleType.FIT_XY)
        logoImage:frame(width - 10 - 110,40 ,110,35)
        logoImage:image(logo["path"])
        cView:addView(logoImage)

        timeBg = Image()
        timeBg:scaleType(ScaleType.FIT_XY)
        timeBg:frame(width - 78 - 10,height - 40 - 30 ,78,30)
        timeBg:image(rectangle["path"])
        cView:addView(timeBg)

        timeLabel = Label()
        timeLabel:frame(width - 78 - 10,height - 40 - 30 ,78,30)
        timeLabel:text(string.format("%ds 跳过",showTime))
        timeLabel:textColor(0xffffff);
        timeLabel:textAlign(TextAlign.CENTER)
        timeLabel:fontSize(12)
        timeLabel:callback(function()
            print("timeLabel click")
            if timer ~= nil then
                timer:cancel()
                timer = nil
            end
            bannerView:adActionClose()
        end)
        cView:addView(timeLabel)

        local clickWidth = width - 50 * 2
        local clickHeight = clickWidth / 752.0 * 142
        clickImage = Image()
        clickImage:scaleType(ScaleType.FIT_XY)
        clickImage:frame(50,height - 45 - 30 - 25 - clickHeight ,clickWidth,clickHeight)
        clickImage:image(clickIcon["path"])
        clickImage:callback(function()
            print("clickImage click")
            local logData = getBaseData()
            logData["act"] = "clk"
            logData["url"] = creative["click"]
            if isCheckExpVersion then
                logData["monitorUrl"] = creative["clkTrackArr"]
                bannerView:adActionExpClickLog(logData)
            else
                logData["monitorUrl"] = creative["clkTrack"]
                bannerView:adActionLog(logData)
            end
        end)
        cView:addView(clickImage)

        timer = Timer()
        timer:interval(1)
        timer:repeatCount(showTime)
        timer:callback(function()
        --定时器回调
            showTime = showTime - 1
            if showTime <= 0 then
                if timer ~= nil then
                    timer:cancel()
                    timer = nil
                end
                bannerView:adActionClose()
            else
                if timeLabel ~= nil then
                    timeLabel:text(string.format("%ds 跳过",showTime))
                end
            end
        end)

        if System.ios() then
            timer:start()
        else
            timer:delay(1)
            timer:start()
        end

    else
        player:voice(0)
        player:restartPlay()
    end
end

--lua bj 广告没有展示在当前屏幕
function hideView()
	print("hideView")
    if player ~= nil then
        player:pausePlay()
    end
end

--lua bj 手动调用离开屏幕，进入屏幕还是showView
function leaveScreen()
    print("leaveScreen")
end

--lua bj 资源准备完成
function sourceReady(sourcedata)
    print("sourceReady")
    for i in pairs(sourcedata) do
        if sourcedata[i]["url"] == icon["url"] then
            icon["path"] = sourcedata[i]["path"]
        elseif sourcedata[i]["url"] == video["url"] then
            video["path"] = sourcedata[i]["path"]
        elseif sourcedata[i]["url"] == logo["url"] then
            logo["path"] = sourcedata[i]["path"]
        elseif sourcedata[i]["url"] == rectangle["url"] then
            rectangle["path"] = sourcedata[i]["path"]
        elseif sourcedata[i]["url"] == cover["url"] then
            cover["path"] = sourcedata[i]["path"]
        elseif sourcedata[i]["url"] == clickIcon["url"] then
            clickIcon["path"] = sourcedata[i]["path"]
        end
    end 
    local size = {}
    size.width = contentWidth
    size.height = contentHeight

    --打请求成功日志
    local logData = getBaseData()
    logData["act"] = "req"
    bannerView:adActionLog(logData)

    bannerView:loadSuccess(size)
end

--lua bj 所有资源销毁
function destroy()
    print("destroy")
    if player ~= nil then
        player:destroy()
    end
    if timer ~= nil then
        timer:cancel()
        timer = nil
    end
    System.gc()
end
