--[[
1.拿到宿主期望宽高
bannerView:getViewWidth()
bannerView:getViewHeight()
2.拿到广告数据 json字符串
bannerView:getADContent()
3.筛选素材后下载素材
bannerView:downloadSource
4.宿主告知素材下载成功
sourceReady(数组{url，path，md5})
5.告诉宿主广告准备成功
bannerView:loadSuccess(size{width,height})
6.宿主告诉lua 是否已经展示在屏幕里
showView()
hideView()
7.宿主告诉lua 销毁
destroy
]]--

--版本控制逻辑
function Split( str,reps )
    local resultStrList = {}
    string.gsub(str,'[^'..reps..']+',function ( w )
        table.insert(resultStrList,w)
    end)
    return resultStrList
end

function getSDKVersion()
    local version = LiLuaADUtils:getADSDKVersion()
    local list = Split(version, ".")
    if #list >= 3 then
        return tonumber(list[1]) * 10000 + tonumber(list[2]) * 100 + tonumber(list[3])
    end
    return 0
end

function isCheckMoreExpVersion()
    local version = getSDKVersion()
    print("isCheckMoreExpVersion "..tostring(version))
    if version >= 30 then
        return true
    end
    return false
end

local isCheckExpVersion = isCheckMoreExpVersion()

--筛选逻辑
local width = bannerView:getViewWidth()
local height = bannerView:getViewHeight()

local margin = 10
local iconMargin = 4

local actWidth = width - 100
local actHeight = actWidth
local adContent = Json:toTable(bannerView:getADContent())

local plans = adContent["plans"]
local plan = plans[1]
local creatives = plan["creatives"]
local creative = creatives[1]
local extendParam = creative["extendParam"]
local videoList = extendParam["videoList"]
local showTime = extendParam["displayTime"]

actHeight = actWidth / videoList[1]["width"] * videoList[1]["height"]

local icon = {}
local iconPostion = extendParam["labelIcon"]["position"]
icon["url"] = extendParam["labelIcon"]["image"]["url"]
icon["md5"] = extendParam["labelIcon"]["image"]["md5"]

local close = {}
close["url"] = extendParam["closeIcon"]["url"]
close["md5"] = extendParam["closeIcon"]["md5"]

local video = {}
video["url"] = videoList[1]["url"]
video["md5"] = videoList[1]["md5"]
local source = {close,video,icon}

local cover = {}
if videoList[1]["cover"] ~= nil and videoList[1]["cover"]["url"] ~= nil then
    cover["url"] = videoList[1]["cover"]["url"]
    cover["md5"] = videoList[1]["cover"]["md5"]
    source[4] = cover
end

--资源下载
bannerView:downloadSource(source)

local videoTrackArr = creative["videoTrackArr"]

local basedata = {}
basedata["lid"] = string.format("%d",adContent["lid"])
basedata["pid"] = string.format("%d",plan["pid"])
basedata["cid"] = string.format("%d",creative["cid"])

local player = nil

local closeImage = nil

local timer = nil

local contentView = nil

local iconImage = nil

local iconWidth = 27

local iconHeight = 19

local checkExpShow = false

function getBaseData()
    local data = {}
    for k,v in pairs(basedata) do
        data[k] = v                                                     
    end
    return data
end

--lua bj 广告展示在当前屏幕
function showView()
    print("showView")
    local logData = getBaseData()
    logData["url"] = ""
    logData["act"] = "exp"
    if checkExpShow == false then
        checkExpShow = true
        if isCheckExpVersion then
            logData["monitorUrl"] = creative["expTrackArr"]
            bannerView:adActionExpClickLog(logData)
        else
            logData["monitorUrl"] = creative["expTrack"]
            bannerView:adActionLog(logData)
        end
    end 

    if contentView == nil then
        contentView = View()
        contentView:frame(0,0,width,height)
        contentView:backgroundColor(0x000000,0.3)
        contentView:callback(function()
            print("contentView click")
            bannerView:adActionClose()
        end)

        player = VideoPlayer()
        player:callback{
            onStart = function(url)
                print("onstart url = "..url)
            end,
            onFinished = function(url)
                print("onFinished url = "..url)
            end,
            onProgress = function(url,playTime,totalTime)
                print("onProgress url = "..url.."playTime="..playTime.." totalTime="..totalTime)
                if videoTrackArr ~= nil and #videoTrackArr > 0 then
                    for i in pairs(videoTrackArr) do
                        local trackTable = videoTrackArr[i]
                        if playTime >= trackTable["timePoint"] and trackTable["isShow"] == nil then
                            trackTable["isShow"] = "1"
                            local logData = getBaseData()
                            logData["url"] = ""
                            logData["act"] = "exp"
                            logData["monitorUrl"] = trackTable["trackUrls"]
                            bannerView:adActionExpClickLog(logData)
                        end
                        if playTime < trackTable["timePoint"] and trackTable["isShow"] ~= nil then
                            trackTable["isShow"] = nil
                        end
                    end
                end
            end,
            onError = function()
                print("onError")
                local logData = getBaseData()
                logData["act"] = "log"
                local log = {}
                log["type"] = "5"
                log["extraInfo"] = video["url"]
                logData["log"] = log
                bannerView:adActionLog(logData)
            end,
            onClick = function()
                print("onClick")
                local logData = getBaseData()
                logData["act"] = "clk"
                logData["url"] = creative["click"]
                if isCheckExpVersion then
                    logData["monitorUrl"] = creative["clkTrackArr"]
                    bannerView:adActionExpClickLog(logData)
                else
                    logData["monitorUrl"] = creative["clkTrack"]
                    bannerView:adActionLog(logData)
                end

                bannerView:adActionClose()
            end
        }
        player:frame((width - actWidth)/2, (height - actHeight)/2, actWidth, actHeight)
        if cover["path"] ~= nil then
            player:startPlay(video["path"],cover["path"])
        else
            player:startPlay(video["path"])
        end
        player:voice(0)
        contentView:addView(player)

        iconImage = Image()
        iconImage:frame(iconMargin+(width - actWidth)/2,iconMargin+(height - actHeight)/2,iconWidth,iconHeight)
        iconImage:image(icon["path"])
        iconImage:scaleType(ScaleType.FIT_XY)
        iconImage:show()
        if iconPostion == 1 then
            iconImage:frame(iconMargin+(width - actWidth)/2,iconMargin+(height - actHeight)/2,iconWidth,iconHeight)
        elseif iconPostion == 2 then
            iconImage:frame((width - actWidth)/2 + actWidth - iconWidth - iconMargin,iconMargin+(height - actHeight)/2,iconWidth,iconHeight)
        elseif iconPostion == 3 then
            iconImage:frame(iconMargin+(width - actWidth)/2,(height - actHeight)/2 + actHeight - iconHeight - iconMargin,iconWidth,iconHeight)
        elseif iconPostion == 4 then
            iconImage:frame((width - actWidth)/2 + actWidth - iconWidth - iconMargin,(height - actHeight)/2 + actHeight - iconHeight- iconMargin,iconWidth,iconHeight)
        else
            iconImage:hide()
        end
        contentView:addView(iconImage)
        
        closeImage = Image()
        closeImage:frame((width - 32)/2,(height - actHeight)/2 + actHeight + 20,32,32)
        closeImage:image(close["path"])
        closeImage:callback(function()
            print("closeImage click")
            if timer ~= nil then
                timer:cancel()
                timer = nil
            end
            bannerView:adActionClose()
        end)
        contentView:addView(closeImage)

        timer = Timer()
        timer:interval(1)
        timer:repeatCount(showTime)
        timer:callback(function()
        --定时器回调
            showTime = showTime - 1
            if showTime <= 0 then
                if timer ~= nil then
                    timer:cancel()
                    timer = nil
                end
                bannerView:adActionClose()
            else
 
            end
        end)

        if System.ios() then
            timer:start()
        else
            timer:delay(1)
            timer:start()
        end
    else
        player:voice(0)
        player:restartPlay()
    end
end

--lua bj 广告没有展示在当前屏幕
function hideView()
	print("hideView")
    if player ~= nil then
        player:voice(0)
        player:pausePlay()
	end
end

--lua bj 手动调用离开屏幕，进入屏幕还是showView
function leaveScreen()
    print("leaveScreen")
end

--lua bj 资源准备完成
function sourceReady(sourcedata)
    print("sourceReady")
    for i in pairs(sourcedata) do
        if sourcedata[i]["url"] == close["url"] then
            close["path"] = sourcedata[i]["path"]
        elseif sourcedata[i]["url"] == video["url"] then
            video["path"] = sourcedata[i]["path"]
        elseif cover["url"] ~= nil and sourcedata[i]["url"] == cover["url"] then
            cover["path"] = sourcedata[i]["path"]
        elseif sourcedata[i]["url"] == icon["url"] then
            icon["path"] = sourcedata[i]["path"]
        end
    end 
    local size = {}
    size.width = width
    size.height = height

    --打请求成功日志
    local logData = getBaseData()
    logData["act"] = "req"
    bannerView:adActionLog(logData)

    bannerView:loadSuccess(size)
end

--lua bj 所有资源销毁
function destroy()
    print("destroy")
    if player ~= nil then
        player:destroy()
    end
    if timer ~= nil then
        timer:cancel()
        timer = nil
    end
    System.gc()
end
