--[[
1.拿到宿主期望宽高
bannerView:getViewWidth()
bannerView:getViewHeight()
2.拿到广告数据 json字符串
bannerView:getADContent()
3.筛选素材后下载素材
bannerView:downloadSource
4.宿主告知素材下载成功
sourceReady(数组{url，path，md5})
5.告诉宿主广告准备成功
bannerView:loadSuccess(size{width,height})
6.宿主告诉lua 是否已经展示在屏幕里
showView()
hideView()
7.宿主告诉lua 销毁
destroy
]]--

--版本控制逻辑
function Split( str,reps )
    local resultStrList = {}
    string.gsub(str,'[^'..reps..']+',function ( w )
        table.insert(resultStrList,w)
    end)
    return resultStrList
end

function getSDKVersion()
    local version = LiLuaADUtils:getADSDKVersion()
    local list = Split(version, ".")
    if #list >= 3 then
        return tonumber(list[1]) * 10000 + tonumber(list[2]) * 100 + tonumber(list[3])
    end
    return 0
end

function isCheckMoreExpVersion()
    local version = getSDKVersion()
    print("isCheckMoreExpVersion "..tostring(version))
    if version >= 30 then
        return true
    end
    return false
end

local isCheckExpVersion = isCheckMoreExpVersion()

--筛选逻辑

local width = bannerView:getViewWidth()
local height = bannerView:getViewHeight()

local margin = 10
local iconMargin = 14

local titleHeight = 68
-- if System.ios() then
--     titleHeight = 44
-- end
local actWidth = width
local actHeight = height
local adContent = Json:toTable(bannerView:getADContent())

local plans = adContent["plans"]
local plan = plans[1]
local creatives = plan["creatives"]
local creative = creatives[1]
local extendParam = creative["extendParam"]
local imageList = extendParam["imageList"]
local labelText = extendParam["text"]

local icon = {}
local iconPostion = extendParam["labelIcon"]["position"]
icon["url"] = extendParam["labelIcon"]["image"]["url"]
icon["md5"] = extendParam["labelIcon"]["image"]["md5"]

local image = {}
image["url"] = imageList[1]["url"]
image["md5"] = imageList[1]["md5"]

local contentWidth = actWidth - margin * 2
local contentHeight = contentWidth * imageList[1]["height"] / imageList[1]["width"]

actHeight = margin + contentHeight

local source = {icon,image}

--资源下载
bannerView:downloadSource(source)

local basedata = {}
basedata["lid"] = string.format("%d",adContent["lid"])
basedata["pid"] = string.format("%d",plan["pid"])
basedata["cid"] = string.format("%d",creative["cid"])

local contentImage = nil

local iconImage = nil

local label = nil

local iconWidth = 27

local iconHeight = 19

local fontSize = 18

local fontBlob = false

local lineSpace = 4

local checkExpShow = false

if System.ios() then
    fontBlob = true
    lineSpace = 6
    if LiLuaUtils:isIPhone4OrLess() then
        fontSize = 16
    elseif LiLuaUtils:isIPhone5() then
        fontSize = 16
    elseif LiLuaUtils:isIPhone6() then
        fontSize = 18
    elseif LiLuaUtils:isIPhoneX() then
        fontSize = 18
    else 
        fontSize = 20
    end
end

function getBaseData()
    local data = {}
    for k,v in pairs(basedata) do
        data[k] = v                                                     
    end
    return data
end

--lua bj 广告展示在当前屏幕
function showView()
    print("showView")
    local logData = getBaseData()
    logData["url"] = ""
    logData["act"] = "exp"
    if checkExpShow == false then
        checkExpShow = true
        if isCheckExpVersion then
            logData["monitorUrl"] = creative["expTrackArr"]
            bannerView:adActionExpClickLog(logData)
        else
            logData["monitorUrl"] = creative["expTrack"]
            bannerView:adActionLog(logData)
        end
    end

    if contentImage == nil then
        local contentBg = View()
        contentBg:backgroundColor(0xffffff)
        contentBg:frame(0,0,actWidth,actHeight + titleHeight)

        contentImage = Image()
        contentImage:frame(margin,margin,contentWidth,contentHeight)
        contentImage:scaleType(ScaleType.FIT_XY)
        contentImage:image(image["path"])
        contentImage:callback(function()
            print("contentImage click")
            local logData = getBaseData()
            logData["act"] = "clk"
            logData["url"] = creative["click"]
            if isCheckExpVersion then
                logData["monitorUrl"] = creative["clkTrackArr"]
                bannerView:adActionExpClickLog(logData)
            else
                logData["monitorUrl"] = creative["clkTrack"]
                bannerView:adActionLog(logData)
            end
        end)
        
        iconImage = Image()
        iconImage:frame(margin,margin,iconWidth,iconHeight)
        iconImage:image(icon["path"])
        iconImage:scaleType(ScaleType.FIT_XY)
        iconImage:show()
        if iconPostion == 1 then
            iconImage:frame(iconMargin,iconMargin,iconWidth,iconHeight)
        elseif iconPostion == 2 then
            iconImage:frame(actWidth - iconWidth - iconMargin,iconMargin,iconWidth,iconHeight)
        elseif iconPostion == 3 then
            iconImage:frame(iconMargin,actHeight - iconHeight - iconMargin,iconWidth,iconHeight)
        elseif iconPostion == 4 then
            iconImage:frame(actWidth - iconWidth - iconMargin,actHeight - iconHeight- iconMargin,iconWidth,iconHeight)
        else
            iconImage:hide()
        end

        label = Label()
        label:frame(margin,actHeight,contentWidth,titleHeight)
        label:backgroundColor(0xffffff)
        label:textAlign(TextAlign.LEFT)
        label:lineCount(2)
        label:ellipsize(Ellipsize.END)
        if fontBlob then
            label:text(StyledString(labelText, {fontSize=fontSize, fontWeight=FontWeight.BOLD, fontColor=0x000000,lineSpace=lineSpace}))
        else
            label:text(StyledString(labelText, {fontSize=fontSize, fontColor=0x000000, lineSpace=lineSpace}))
        end
    else

    end
end

--lua bj 广告没有展示在当前屏幕
function hideView()
	print("hideView")
end

--lua bj 手动调用离开屏幕，进入屏幕还是showView
function leaveScreen()
    print("leaveScreen")
end

--lua bj 资源准备完成
function sourceReady(sourcedata)
    print("sourceReady")
    for i in pairs(sourcedata) do
        if sourcedata[i]["url"] == icon["url"] then
            icon["path"] = sourcedata[i]["path"]
        elseif sourcedata[i]["url"] == image["url"] then
            image["path"] = sourcedata[i]["path"]
        end
    end 
    local size = {}
    size.width = actWidth
    size.height = actHeight + titleHeight

    --打请求成功日志
    local logData = getBaseData()
    logData["act"] = "req"
    bannerView:adActionLog(logData)

    bannerView:loadSuccess(size)
end

--lua bj 所有资源销毁
function destroy()
    print("destroy")
    System.gc()
end
