--[[
1.拿到宿主期望宽高
bannerView:getViewWidth()
bannerView:getViewHeight()
2.拿到广告数据 json字符串
bannerView:getADContent()
3.筛选素材后下载素材
bannerView:downloadSource
4.宿主告知素材下载成功
sourceReady(数组{url，path，md5})
5.告诉宿主广告准备成功
bannerView:loadSuccess(size{width,height})
6.宿主告诉lua 是否已经展示在屏幕里
showView()
hideView()
7.宿主告诉lua 销毁
destroy
]]--

--版本控制逻辑
function Split( str,reps )
    local resultStrList = {}
    string.gsub(str,'[^'..reps..']+',function ( w )
        table.insert(resultStrList,w)
    end)
    return resultStrList
end

function getSDKVersion()
    local version = LiLuaADUtils:getADSDKVersion()
    local list = Split(version, ".")
    if #list >= 3 then
        return tonumber(list[1]) * 10000 + tonumber(list[2]) * 100 + tonumber(list[3])
    end
    return 0
end

function isCheckMoreExpVersion()
    local version = getSDKVersion()
    print("isCheckMoreExpVersion "..tostring(version))
    if version >= 30 then
        return true
    end
    return false
end

local isCheckExpVersion = isCheckMoreExpVersion()

--筛选逻辑

local width = bannerView:getViewWidth()
local height = bannerView:getViewHeight()

local margin = 10
local iconMargin = 14

local titleHeight = 44
local userAreaHeight = 38

local actWidth = width
local actHeight = height
local adContent = Json:toTable(bannerView:getADContent())

local plans = adContent["plans"]
local plan = plans[1]
local creatives = plan["creatives"]
local creative = creatives[1]
local extendParam = creative["extendParam"]
local videoList = extendParam["videoList"]
local labelText = extendParam["text"]
local userInfo = extendParam["userInfo"]

local video = {}
video["url"] = videoList[1]["url"]
video["md5"] = videoList[1]["md5"]

local userIcon = {}
userIcon["url"] = userInfo["image"]["url"]
userIcon["md5"] = userInfo["image"]["md5"]

local userIconBg = {}
userIconBg["url"] = userInfo["imageBg"]["url"]
userIconBg["md5"] = userInfo["imageBg"]["md5"]

local labelIcon = {}
labelIcon["url"] = userInfo["labelIcon"]["url"]
labelIcon["md5"] = userInfo["labelIcon"]["md5"]

local userLabelText = userInfo["text"]

local contentWidth = actWidth - margin * 2
local contentHeight = contentWidth * videoList[1]["height"] / videoList[1]["width"]

actHeight = margin + contentHeight

local sound_mute = {}
local soundPostion = extendParam["muteIcon"]["position"]
sound_mute["url"] = extendParam["muteIcon"]["muteImage"]["url"]
sound_mute["md5"] = extendParam["muteIcon"]["muteImage"]["md5"]
local sound_unmute = {}
sound_unmute["url"] = extendParam["muteIcon"]["unmuteImage"]["url"]
sound_unmute["md5"] = extendParam["muteIcon"]["unmuteImage"]["md5"]
local source = {video,sound_mute,sound_unmute,userIcon,userIconBg,labelIcon}
local cover = {}
if videoList[1]["cover"] ~= nil and videoList[1]["cover"]["url"] ~= nil then
    cover["url"] = videoList[1]["cover"]["url"]
    cover["md5"] = videoList[1]["cover"]["md5"]
    source[7] = cover
end

local totalHeight = actHeight + titleHeight - 5 + userAreaHeight

--资源下载
bannerView:downloadSource(source)

local videoTrackArr = creative["videoTrackArr"]

local basedata = {}
basedata["lid"] = string.format("%d",adContent["lid"])
basedata["pid"] = string.format("%d",plan["pid"])
basedata["cid"] = string.format("%d",creative["cid"])

local player = nil

local iconImage = nil

local soundImage = nil

local isSoundMute = false

local soundMargin = 10;

local soundWidth = 25

local soundHeight = 25

local fontSize = 18

local fontBlob = false

local progressBar = nil
local clickLabel = nil
local labelWidth = LiLuaUtils:widthForString({label=userLabelText,fontSize=10,height=14})
local downloadState = "IDLE" -- IDLE,ERROR,DOWNLOADING,SUCCESS,PAUSE,OPEN
local progress = "0"

local checkExpShow = false

function getBaseData()
    local data = {}
    for k,v in pairs(basedata) do
        data[k] = v                                                     
    end
    return data
end

if System.ios() then
    fontBlob = true
    if LiLuaUtils:isIPhone4OrLess() then
        fontSize = 16
    elseif LiLuaUtils:isIPhone5() then
        fontSize = 16
    elseif LiLuaUtils:isIPhone6() then
        fontSize = 18
    elseif LiLuaUtils:isIPhoneX() then
        fontSize = 18
    else 
        fontSize = 20
    end
end

--lua bj 广告展示在当前屏幕
function showView()
    print("showView")
    local logData = getBaseData()
    logData["url"] = ""
    logData["act"] = "exp"
    if checkExpShow == false then
        checkExpShow = true
        if isCheckExpVersion then
            logData["monitorUrl"] = creative["expTrackArr"]
            bannerView:adActionExpClickLog(logData)
        else
            logData["monitorUrl"] = creative["expTrack"]
            bannerView:adActionLog(logData)
        end
    end

    if player == nil then
        local contentBg = View()
        contentBg:backgroundColor(0xffffff)
        contentBg:frame(0,0,actWidth,totalHeight)
        contentBg:callback(function()
            print("onClick")
            if System.ios() then
                local logData = getBaseData()
                logData["act"] = "clk"
                logData["url"] = creative["click"]
                if isCheckExpVersion then
                    logData["monitorUrl"] = creative["clkTrackArr"]
                    bannerView:adActionExpClickLog(logData)
                else
                    logData["monitorUrl"] = creative["clkTrack"]
                    bannerView:adActionLog(logData)
                end
            else
                if downloadState == "IDLE" then
                    downloadState = "DOWNLOADING"
                    progressBar:show()
                    progressBar:progress(0)
                    clickLabel:textColor(0xFFFFFF)
                    clickLabel:text("已下载0%")
                    clickLabel:borderColor(0xFFFFFF)
                    bannerView:adActionSimpleClick(extendParam["apk"]["startdownload"])
                    bannerView:downloadNativeStatus({state=downloadState,url=extendParam["apk"]["url"],md5=extendParam["apk"]["md5"],bundle=extendParam["apk"]["bundle"]})
                    bannerView:showToastMsg("已开始下载")
                end
            end
        end)

        player = VideoPlayer()
        player:callback{
            onStart = function(url)
                print("onstart url = "..url)
            end,
            onFinished = function(url)
                print("onFinished url = "..url)
            end,
            onProgress = function(url,playTime,totalTime)
                print("onProgress url = "..url.."playTime="..playTime.." totalTime="..totalTime)
                if videoTrackArr ~= nil and #videoTrackArr > 0 then
                    for i in pairs(videoTrackArr) do
                        local trackTable = videoTrackArr[i]
                        if playTime >= trackTable["timePoint"] and trackTable["isShow"] == nil then
                            trackTable["isShow"] = "1"
                            local logData = getBaseData()
                            logData["url"] = ""
                            logData["act"] = "exp"
                            logData["monitorUrl"] = trackTable["trackUrls"]
                            bannerView:adActionExpClickLog(logData)
                        end
                        if playTime < trackTable["timePoint"] and trackTable["isShow"] ~= nil then
                            trackTable["isShow"] = nil
                        end
                    end
                end
            end,
            onError = function()
                print("onError")
                local logData = getBaseData()
                logData["act"] = "log"
                local log = {}
                log["type"] = "5"
                log["extraInfo"] = video["url"]
                logData["log"] = log
                bannerView:adActionLog(logData)
            end,
            onClick = function()
                print("onClick player")
                if System.ios() then
                    local logData = getBaseData()
                    logData["act"] = "clk"
                    logData["url"] = creative["click"]
                    if isCheckExpVersion then
                        logData["monitorUrl"] = creative["clkTrackArr"]
                        bannerView:adActionExpClickLog(logData)
                    else
                        logData["monitorUrl"] = creative["clkTrack"]
                        bannerView:adActionLog(logData)
                    end
                else
                    if downloadState == "IDLE" then
                        downloadState = "DOWNLOADING"
                        progressBar:show()
                        progressBar:progress(0)
                        clickLabel:textColor(0xFFFFFF)
                        clickLabel:text("已下载0%")
                        clickLabel:borderColor(0xFFFFFF)
                        bannerView:adActionSimpleClick(extendParam["apk"]["startdownload"])
                        bannerView:downloadNativeStatus({state=downloadState,url=extendParam["apk"]["url"],md5=extendParam["apk"]["md5"],bundle=extendParam["apk"]["bundle"]})
                        bannerView:showToastMsg("已开始下载")
                    end
                end
            end
        }
        player:frame(margin, margin, contentWidth, contentHeight)
        if cover["path"] ~= nil then
            player:startPlay(video["path"],cover["path"],"1")
        else
            player:startPlay(video["path"],"","1")
        end

        soundImage = Image()
        soundImage:scaleType(ScaleType.FIT_XY)
        soundImage:frame(actWidth - soundMargin - soundWidth - margin,soundMargin + margin,soundWidth,soundHeight)
        soundImage:show()

        if soundPostion == 1 then
            soundImage:frame(soundMargin + margin,soundMargin + margin,soundWidth,soundHeight)
        elseif soundPostion == 2 then
            soundImage:frame(actWidth - soundMargin - soundWidth - margin,soundMargin + margin,soundWidth,soundHeight)
        elseif soundPostion == 3 then
            soundImage:frame(soundMargin + margin,actHeight - soundMargin - soundHeight - margin,soundWidth,soundHeight)
        elseif soundPostion == 4 then
            soundImage:frame(actWidth - soundMargin - soundWidth - margin,actHeight - soundMargin - soundHeight - margin,soundWidth,soundHeight)
        else
            soundImage:hide()
        end

        if isSoundMute then
            soundImage:image(sound_unmute["path"])
            player:voice(0.5)
        else
            soundImage:image(sound_mute["path"])
            player:voice(0)
        end
        soundImage:callback(function()
            if isSoundMute then
                isSoundMute = false
                soundImage:image(sound_mute["path"])
                player:voice(0)
            else
                isSoundMute = true
                soundImage:image(sound_unmute["path"])
                player:voice(0.5)
            end
            print("sound click")
        end)

        local label = Label()
        label:frame(margin,actHeight,contentWidth,titleHeight)
        label:backgroundColor(0xffffff);
        label:textAlign(TextAlign.LEFT)
        label:lineCount(0.3)
        label:ellipsize(Ellipsize.END)
        if fontBlod then
            label:text(StyledString(labelText, {fontSize=fontSize, fontWeight=FontWeight.BOLD, fontColor=0x000000}))
        else
            label:text(StyledString(labelText, {fontSize=fontSize, fontColor=0x000000}))
        end

        local userImage = Image()
        userImage:frame(margin,actHeight + titleHeight - 3,20,20)
        userImage:scaleType(ScaleType.FIT_XY)
        userImage:image(userIcon["path"])

        local userBgImage = Image()
        userBgImage:frame(margin,actHeight + titleHeight - 3,20,20)
        userBgImage:scaleType(ScaleType.FIT_XY)
        userBgImage:image(userIconBg["path"])

        local userLabel = Label()
        userLabel:frame(margin + 25,actHeight + titleHeight,labelWidth,14)
        userLabel:textAlign(TextAlign.LEFT)
        userLabel:lineCount(1)
        userLabel:ellipsize(Ellipsize.END)
        userLabel:text(StyledString(userLabelText, {fontSize=10, fontColor=0x999999}))

        local adImage = Image()
        adImage:frame(margin + 35 + labelWidth,actHeight + titleHeight,28,14)
        adImage:scaleType(ScaleType.FIT_XY)
        adImage:image(labelIcon["path"])

        if System.android() then 
            progressBar = LiProgressBar()
            progressBar:frame(actWidth - 75 - margin,actHeight + titleHeight - 5,75,24)
            progressBar:progressTheme(0xFF6200,0xD7D7D7,12)
            progressBar:hide()
        end

        clickLabel = Label()
        clickLabel:frame(actWidth - 75 - margin,actHeight + titleHeight - 5,75,24)
        clickLabel:textAlign(TextAlign.CENTER)
        clickLabel:textColor(0xFF6200)
        clickLabel:textSize(12)
        clickLabel:text("立即下载")
        clickLabel:cornerRadius(12)
        clickLabel:borderWidth(1)
        clickLabel:borderColor(0xFF6200)

        clickLabel:callback(function()
            print("clickLabel click")
            if System.ios() then
                local logData = getBaseData()
                logData["act"] = "clk"
                logData["url"] = creative["click"]
                logData["monitorUrl"] = creative["clkTrackArr"]
                bannerView:adActionExpClickLog(logData)
            else
                if extendParam["apk"] ~= nil then 
                    if downloadState == "IDLE" then
                        downloadState = "DOWNLOADING"
                        progressBar:show()
                        progressBar:progress(0)
                        clickLabel:textColor(0xFFFFFF)
                        clickLabel:text("已下载0%")
                        clickLabel:cornerRadius(0)
                        clickLabel:borderWidth(0)
                        clickLabel:borderColor(0xFFFFFF)
                        bannerView:adActionSimpleClick(extendParam["apk"]["startdownload"])
                        bannerView:downloadNativeStatus({state=downloadState,url=extendParam["apk"]["url"],md5=extendParam["apk"]["md5"],bundle=extendParam["apk"]["bundle"]})
                        bannerView:showToastMsg("已开始下载")
                    elseif downloadState == "ERROR" then
                        downloadState = "DOWNLOADING"
                        progressBar:show()
                        progressBar:progress(0)
                        clickLabel:cornerRadius(0)
                        clickLabel:borderWidth(0)
                        clickLabel:textColor(0xFFFFFF)
                        clickLabel:text("已下载0%")
                        clickLabel:borderColor(0xFFFFFF)
                        bannerView:downloadNativeStatus({state=downloadState,url=extendParam["apk"]["url"],md5=extendParam["apk"]["md5"],bundle=extendParam["apk"]["bundle"]})
                    elseif downloadState == "SUCCESS" then
                        isAutoInstall = false
                        bannerView:adActionSimpleClick(extendParam["apk"]["startinstall"])
                        bannerView:downloadNativeStatus({state=downloadState})
                    elseif downloadState == "PAUSE" then
                        downloadState = "DOWNLOADING"
                        progressBar:show()
                        progressBar:progress(tonumber(progress))
                        clickLabel:cornerRadius(0)
                        clickLabel:borderWidth(0)
                        clickLabel:textColor(0xFFFFFF)
                        clickLabel:text("已下载"..progress.."%")
                        clickLabel:borderColor(0xFFFFFF)
                        bannerView:downloadNativeStatus({state=downloadState,url=extendParam["apk"]["url"],md5=extendParam["apk"]["md5"],bundle=extendParam["apk"]["bundle"]})
                    elseif downloadState == "DOWNLOADING" then
                        downloadState = "PAUSE"
                        bannerView:downloadNativeStatus({state=downloadState})
                        progressBar:hide()
                        clickLabel:cornerRadius(12)
                        clickLabel:borderWidth(1)
                        clickLabel:textColor(0xFF6200)
                        clickLabel:text("继续下载")
                        clickLabel:borderColor(0xFF6200)
                    elseif downloadState == "OPEN" then
                        bannerView:downloadNativeStatus({state=downloadState})
                    else

                    end
                end
            end
        end)

    else
        isSoundMute = false
        soundImage:image(sound_mute["path"])
        player:voice(0)
        player:restartPlay()
    end
end

--lua bj 广告没有展示在当前屏幕
function hideView()
	print("hideView")
    if player ~= nil then
        isSoundMute = false
        soundImage:image(sound_mute["path"])
        player:voice(0)
        player:pausePlay()
	end
end

--lua bj 手动调用离开屏幕，进入屏幕还是showView
function leaveScreen()
    print("leaveScreen")
    if player ~= nil then
        isSoundMute = false
        soundImage:image(sound_mute["path"])
        player:voice(0)
	end
end

--lua bj 资源准备完成
function sourceReady(sourcedata)
    print("sourceReady")
    for i in pairs(sourcedata) do
        if sourcedata[i]["url"] == userIcon["url"] then
            userIcon["path"] = sourcedata[i]["path"]
        elseif sourcedata[i]["url"] == userIconBg["url"] then
            userIconBg["path"] = sourcedata[i]["path"]
        elseif sourcedata[i]["url"] == video["url"] then
            video["path"] = sourcedata[i]["path"]
        elseif cover["url"] ~= nil and sourcedata[i]["url"] == cover["url"] then
            cover["path"] = sourcedata[i]["path"]
        elseif sourcedata[i]["url"] == sound_mute["url"] then
            sound_mute["path"] = sourcedata[i]["path"]
        elseif sourcedata[i]["url"] == sound_unmute["url"] then
            sound_unmute["path"] = sourcedata[i]["path"]
        elseif sourcedata[i]["url"] == labelIcon["url"] then
            labelIcon["path"] = sourcedata[i]["path"]
        end
    end 
    local size = {}
    size.width = actWidth
    size.height = totalHeight

    --打请求成功日志
    local logData = getBaseData()
    logData["act"] = "req"
    bannerView:adActionLog(logData)

    bannerView:loadSuccess(size)
end

function downloadLuaStatus(sourcedata)
    local state = sourcedata["state"]
    downloadState = state
    if downloadState == "IDLE" then

    elseif downloadState == "ERROR" then
        progressBar:hide()
        progressBar:progress(0)
        clickLabel:cornerRadius(12)
        clickLabel:borderWidth(1)
        clickLabel:textColor(0xFF6200)
        clickLabel:text("下载失败")
        clickLabel:borderColor(0xFF6200)
    elseif downloadState == "SUCCESS" then
        bannerView:adActionSimpleClick(extendParam["apk"]["finishdownload"])
        progressBar:show()
        progressBar:progress(100)
        clickLabel:cornerRadius(0)
        clickLabel:borderWidth(0)
        clickLabel:textColor(0xFFFFFF)
        clickLabel:borderColor(0xFFFFFF)
        clickLabel:text("点击安装")
        bannerView:showToastMsg("下载完成,3秒后自动弹出安装")
        isAutoInstall = true
        installTimer = Timer()
        installTimer:delay(2)
        installTimer:callback(function()
            print("----------installTimer")
            --定时器回调
            if isAutoInstall then
                bannerView:adActionSimpleClick(extendParam["apk"]["startinstall"])
                bannerView:downloadNativeStatus({state=downloadState})
            end
            isAutoInstall = false
            if installTimer ~= nil then
                installTimer:cancel()
                installTimer = nil
            end
        end)
        installTimer:start()
    elseif downloadState == "PAUSE" then
        
    elseif downloadState == "DOWNLOADING" then
        progress = sourcedata["progress"]
        progressBar:progress(tonumber(progress))
        clickLabel:text("已下载"..progress.."%")
        progressBar:show()
        clickLabel:cornerRadius(0)
        clickLabel:borderWidth(0)
        clickLabel:textColor(0xFFFFFF)
        clickLabel:borderColor(0xFFFFFF)
    elseif downloadState == "OPEN" then
        bannerView:adActionSimpleClick(extendParam["apk"]["finishinstall"])
        progressBar:show()
        progressBar:progress(100)
        clickLabel:cornerRadius(0)
        clickLabel:borderWidth(0)
        clickLabel:textColor(0xFFFFFF)
        clickLabel:borderColor(0xFFFFFF)
        clickLabel:text("打开应用")
    else

    end
end

--lua bj 所有资源销毁
function destroy()
    print("destroy")
    if player ~= nil then
        player:destroy()
    end
    System.gc()
end
