
--------------------- 控制逻辑 ------------------------
local adData = bannerView:getADData()
local adContentStr = adData["adContent"]
local adContent = Json:toTable(adContentStr)
local source = {}
local vpType = "1"
if adData["vpType"] ~= nil then
    vpType = adData["vpType"]
end

local plans = adContent["plans"]
local plan = plans[1]
local creatives = plan["creatives"]

--预处理数据
for i in pairs(creatives) do
    if creatives[i]["lua"] ~= nil then
        local lua = creatives[i]["lua"]
        local s = {}
        s["url"] = lua["url"]
        s["md5"] = lua["md5"]
        source[#source + 1] = s
    end
    local extendParam = creatives[i]["extendParam"]
    local imageSource = extendParam["image"]
    if imageSource ~= nil then
        local s = {}
        s["url"] = imageSource["url"]
        s["md5"] = imageSource["md5"]
        source[#source + 1] = s
    end
end

function updateData(str)
    if str ~= nil then
        adData["adContent"] = str
        adContentStr = str
        bannerView:updateADContent(str)
        adContent = Json:toTable(adData["adContent"])
        plans = adContent["plans"]
        plan = plans[1]
        creatives = plan["creatives"]
        bannerView:updateADContent(str)
    end
end

--预加载资源
if #source > 0 then
    bannerView:preDownloadSource(source)
end

--开启播放时间监控
bannerView:adStartTimer()

--宿主调用暂停
function bjPauseView()

end

--宿主调用继续
function bjResumeView()
    
end

--宿主调用设置大小
function bjSetFrame(frameTable)
    
end

--宿主调用设置时间
function bjSetTime(time)
    local currTime = time
    if vpType ~= nil and vpType == "2" then
        currTime = LiLuaTimeUtils:getDateStampShort()
    end
    for i in pairs(creatives) do
        if creatives[i]["isShow"] == nil then
            if creatives[i]["floatTime"] ~= nil and #(creatives[i]["floatTime"]) > 0 then
                local createNewView = false
                for j in pairs(creatives[i]["floatTime"]) do
                    local timeTable = creatives[i]["floatTime"][j]
                    if currTime >= timeTable["startSecond"] and currTime <= timeTable["startSecond"] + timeTable["duration"] then
                        createNewView = true
                        creatives[i]["isShow"] = "1"
                        break
                    end
                end
                if createNewView == true and creatives[i]["lua"] ~= nil then
                    local createTable = {act="createView",url=creatives[i]["lua"]["url"],md5=creatives[i]["lua"]["md5"],localName="vp_image",creative=creatives[i],adContent=adContentStr}
                    bannerView:sendNativeAction(createTable)
                end
            end
        end
    end
end

--宿主设置资源加载完成
function bjSourceReady(sourcedata)
    
end

--宿主调用销毁
function bjDestroy()
    bannerView:adStopTimer()
end
