--------------------- 控制逻辑 ------------------------
local adData = bannerView:getADData()
local creative = adData["creative"]
local adContent = Json:toTable(adData["adContent"])
local source = {}
local vpType = "1"
if adData["vpType"] ~= nil then
    vpType = adData["vpType"]
end
local extendParam = creative["extendParam"]
local imageSource = extendParam["image"]
local closeImageSource = extendParam["floatCloseBtn"]
local sourceReady = false
local frameTable = {}

local aspectRatio = 0
if extendParam["aspectRatio"] ~= nil and extendParam["aspectRatio"] == 1 then
    aspectRatio = 1
end

local showCloseBtn = 0
if extendParam["showCloseBtn"] ~= nil and extendParam["showCloseBtn"] == 1 and closeImageSource ~= nil then
    showCloseBtn = 1
end

local basedata = {}
basedata["lid"] = string.format("%d",adContent["lid"])
basedata["pid"] = string.format("%d",adContent["plans"][1]["pid"])
basedata["cid"] = string.format("%d",creative["cid"])

local image = {}
image["url"] = imageSource["url"]
image["md5"] = imageSource["md5"]
source[#source + 1] = image

local imageClose = {}
if showCloseBtn == 1 then
    imageClose["url"] = closeImageSource["url"]
    imageClose["md5"] = closeImageSource["md5"]
    source[#source + 1] = imageClose
end

--预加载资源
if #source > 0 then
    bannerView:downloadSource(source)
end

local contentImage = nil
local closeImage = nil
local isShow = false
local showTimeIndex = 0
local closeImageWidth = 20
local closeImageHeight = 20

function getBaseData()
    local data = {}
    for k,v in pairs(basedata) do
        data[k] = v
    end
    return data
end


--宿主调用暂停
function bjPauseView()

end

--宿主调用继续
function bjResumeView()

end

--宿主调用设置大小
function bjSetFrame(frame)
    frameTable = frame
    if sourceReady == false then
        return
    end
    if isShow == true then
        showView()
    end
end

--宿主调用设置时间
function bjSetTime(time)
    if sourceReady == false then
        return
    end
    local currTime = time
    if vpType ~= nil and vpType == "2" then
        currTime = LiLuaTimeUtils:getDateStampShort()
    end
    checkView(currTime)
end

--宿主设置资源加载完成
function bjSourceReady(sourcedata)
    for i in pairs(sourcedata) do
        if sourcedata[i]["url"] == image["url"] then
            image["path"] = sourcedata[i]["path"]
        elseif showCloseBtn == 1 and sourcedata[i]["url"] == imageClose["url"] then
            imageClose["path"] = sourcedata[i]["path"]
        end
    end
    if sourceReady == false then
        sourceReady = true
        frameTable = bannerView:getAdFrame()
    end
end

--宿主调用销毁
function bjDestroy()

end

function checkView(time)
    if creative["floatTime"] ~= nil and #(creative["floatTime"]) > 0 then
        local isHasShow = false
        for j in pairs(creative["floatTime"]) do
            local timeTable = creative["floatTime"][j]
            if timeTable["close"] == nil then
                if time >= timeTable["startSecond"] and time <= timeTable["startSecond"] + timeTable["duration"] then
                    if contentImage == nil or contentImage:isHide() == true then
                        local logData = getBaseData()
                        logData["url"] = ""
                        logData["act"] = "exp"
                        logData["monitorUrl"] = creative["expTrackArr"]
                        bannerView:adActionExpClickLog(logData)
                    end
                    showTimeIndex = j
                    isShow = true
                    isHasShow = true
                    showView()
                    break
                end
            end
        end

        if isHasShow == false and contentImage ~= nil then
            isShow = false
            contentImage:hide()
            if showCloseBtn == 1 then
                closeImage:hide()
            end
        end
    end
end

function showView()
    if imageSource["floatLocation"] == nil then
        return
    end
    local visWidth = 640
    local visHeight = 360
    if aspectRatio == 1 then
        visWidth = 360
        visHeight = 640
    end
    local actX = frameTable["width"] / visWidth * imageSource["floatLocation"]["x"]
    local actWidth = frameTable["width"] / visWidth * (imageSource["floatLocation"]["x2"] - imageSource["floatLocation"]["x"])
    local actY = frameTable["height"] / visHeight * imageSource["floatLocation"]["y"]
    local actHeight = frameTable["height"] / visHeight * (imageSource["floatLocation"]["y2"] - imageSource["floatLocation"]["y"])
    if contentImage == nil then
        contentImage = Image()
        contentImage:scaleType(ScaleType.FIT_XY)
        contentImage:frame(actX,actY,actWidth,actHeight)
        contentImage:image(image["path"])
        contentImage:callback(function()
            local logData = getBaseData()
            logData["act"] = "clk"
            logData["url"] = creative["click"]
            logData["monitorUrl"] = creative["clkTrackArr"]
            bannerView:adActionExpClickLog(logData)
        end)
        if showCloseBtn == 1 then
            closeImage = Image()
            closeImage:scaleType(ScaleType.FIT_XY)
            closeImage:frame(actX + actWidth - closeImageWidth,actY - closeImageHeight,closeImageWidth,closeImageHeight)
            closeImage:image(imageClose["path"])
            closeImage:callback(function()
                local timeTable = creative["floatTime"][showTimeIndex]
                timeTable["close"] = 1
                isShow = false
                contentImage:hide()
                closeImage:hide()
            end)
        end
    else
        contentImage:frame(actX,actY,actWidth,actHeight)
        closeImage:frame(actX + actWidth - closeImageWidth,actY - closeImageHeight,closeImageWidth,closeImageHeight)
    end
    contentImage:show()
    if showCloseBtn == 1 then
        closeImage:show()
    end
end
